      function chisq(par)
************************************************************************
*                                                                      *
*     Compute and return the value of chisq.                           *
*     Version of Jan 19, 2000.                                         *
*                                                                      *
************************************************************************
$include apeno.h
$include grids.h
$include gss32.h
$include datacom.h
$include dsped.h
      dimension y(meqn*mxgrd), f(meqn)
      double precision par(*)
      common /extras/ eps, h1, hmin, alsq, neqn
************************************************************************
*                                                                      *
*     Initialise the parton densities.                                 *
*                                                                      *
************************************************************************
      nf=neff(0)
      positive=1.0
      call initg1(y,par,positive)
      chisq=positive
      call spline(y)
************************************************************************
*                                                                      *
*     Integrate the evolution equations.                               *
*                                                                      *
************************************************************************
      do 20 iq=1,nqgrd
         if (neff(iq).ne.nf) then
            nf=neff(iq)
            go to 20
         end if
************************************************************************
*        Compute the value of chisq for all the data.                  *
************************************************************************
        do 21 iexp=1,nexp
           kode=key(iexp)
           if ((kode.ne.kprot).and.(kode.ne.kdeut).and.
     1          (kode.ne.kneut)) go to 21
           do 22 ix=1,ndx
              iptr=indx(ix,iexp,iq)
              if (iptr.gt.0) then
                 a1=g1(iq,ix,kode)
                 chisq=chisq+(d(iptr)-a1)**2/sg(iptr)
              end if
22            continue
21         continue
20      continue
*
      write(*,'(a,14e14.6)') ']', chisq, (par(i),i=1,12)
*
      return
      end
